=== debian/control ===
Source: ros-crystal-behaviortree-cpp
Section: misc
Priority: extra
Maintainer: Michele Colledanchise <michele.colledanchise@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libzmq3-dev, ros-crystal-ament-cmake, ros-crystal-ament-cmake-gtest, ros-crystal-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-crystal-behaviortree-cpp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libzmq3-dev, ros-crystal-ros-workspace
Description: This package provides a behavior trees core.
